from slic.core.acquisition import DetectorConfig

#detectors = [
#    "JF15T08V01"
#]

detectors = DetectorConfig()
detectors.add("JF15T08V01", save_dap_results=True)



#    "SLAAR11-LTIM01-EVR0:DUMMY_PV5_NBS",
channels_nbs = [
    f"SATES20-CVME-EVR0:DUMMY_PV{i+1}_NBS" for i in range(10)
]


channels_inten = [
    "SATFE10-PEPG046:PHOTON-ENERGY-PER-PULSE-AVG",
    "SATFE10-PEPG046-EVR0:CALCI",
    "SATFE10-PEPG046-EVR0:CALCS",
    "SATFE10-PEPG046-EVR0:CALCT",
    "SATFE10-PEPG046-EVR0:CALCX",
    "SATFE10-PEPG046-EVR0:CALCY",
    "SATFE10-PEPG046:FCUP-INTENSITY-AVG",
    "SATFE10-PEPG046:FCUP-INTENSITY-CAL",
]

# CH 0-3 farday cup / 4&5 multipliers
channels_inten += [
    f"SATFE10-LSCP1:CH{n}:1" for n in range(6)
]


channels_ks = [
#   "SATES21-GES1:PR1_SPIKES",
#    "SATES21-GES1:A1_VALUES",
    "SATES21-GES1:A2_VALUES",
#    "SATES21-GES1:A3_VALUES",
#    "SATES21-GES1:A4_VALUES",
#    "SATES21-GES1:A1_VALUES_MH",
#    "SATES21-GES1:A2_VALUES_MH",
#    "SATES21-GES1:A3_VALUES_MH",
#    "SATES21-GES1:A4_VALUES_MH",
#    "SATES21-GES1:B1_VALUES",
#    "SATES21-GES1:B2_VALUES",
#    "SATES21-GES1:B3_VALUES",
#    "SATES21-GES1:B4_VALUES",
#    "SATES21-GES1:B1_VALUES_MH",
#    "SATES21-GES1:B2_VALUES_MH",
#    "SATES21-GES1:B3_VALUES_MH",
#    "SATES21-GES1:B4_VALUES_MH",
#    "SATES21-GES1:PR1_NBS_ANA_DELAY",
#    "SATES21-GES1:PR1_NBS_RAW_DELAY",
#    "SATES21-GES1:PR1_SPIKES",
#    "SATES21-GES1:PR1_SPIKES_MH",
]

channels_ioxos = [
    "SATES20-LSCP10:CH0:1",
    "SATES20-LSCP10-FNS:CH0:VAL_GET",
#    "SATES20-LSCP10:CH0:2",
    "SATES20-LSCP10:CH1:1",
#    "SATES20-LSCP10:CH2:0",
    "SATES20-LSCP10:CH2:1",
    "SATES20-LSCP10:CH3:1",
#    "SATES20-LSCP10:CH6:2",
#    "SLAAT21-LSCP01:CH0:1",
#    "SLAAT21-LSCP01-FNS:CH0:VAL_GET",
]

channels_ocean_optics = [
    "SLAAT01-LSPC-SPEC1:SPECTRUM",
    "SLAAT01-LSPC-SPEC1:WAVELENGTHS"
]

channels_events = [
    "SAT-CVME-TIFALL5:EvtSet",
]

channels_calc_I = [
    "SATFE10-LSCP1:CH0:1",
    "SATFE10-LSCP1:CH1:1",
    "SATFE10-LSCP1:CH2:1",
    "SATFE10-LSCP1:CH3:1",
    "SATFE10-LSCP1:CH4:1",
    "SATFE10-LSCP1:CH5:1"
]

#channels_cam_gige = [
#    f"SATES21-CAMS154-GIGE{i+1}:FPICTURE" for i in range(8)
#]

channels_cam_gige = [
#   "SATES21-CAMS154-GIGE1:FPICTURE"
#   "SATES21-CAMS154-GIGE3:FPICTURE"
#    "SATES21-CAMS154-GIGE2:FPICTURE"
#    "SATES21-CAMS154-GIGE4:FPICTURE"
#    "SATES21-CAMS154-GIGE5:FPICTURE"
#     "SATES21-CAMS154-GIGE6:FPICTURE",
#     "SATES21-CAMS154-GIGE7:FPICTURE",
#     "SATES21-CAMS154-GIGE8:FPICTURE",
#    "SLAAT01-LCAM-C603:FPICTURE"
]

channels_cam_axis = [
#    "SATES20-HOLO-CAM01:FPICTURE"
]

channels_cam_pco = [
    "SATES21-CAMS154-M1:FPICTURE",
#    "SATES24-CAMS161-M1:FPICTURE",
#    "SATES21-CAMS-PATT1:FPICTURE",
#    "SATES21-CAMS154-M2:FPICTURE",

#    "SATBD02-DSCR050:FPICTURE",
]

names_cam_pco = [
    "SATES21-CAMS154-M1",
#    "SATES24-CAMS161-M1",
#    "SATES21-CAMS-PATT1",
#    "SATES21-CAMS154-M2",

]
suffices_proc = [
    "processing_parameters",
    "projection_background",
    "projection_signal",
#    "projection_radial_bins",
#    "projection_radial_counts",
]

BAM_channels = [
    "SINLH01-DBAM010:ADC0-DATA",
    "SINLH01-DBAM010:ADC1-DATA",
    "SINLH01-DBAM010:BAM_CH1_NORM",
    "SINLH01-DBAM010:BAM_CH2_NORM",
    'SINLH01-DBAM010:EOM1_RESOLUTION1',
    'SINLH01-DBAM010:EOM1_RESOLUTION2',
    'SINLH01-DBAM010:EOM1_T1',
    'SINLH01-DBAM010:EOM1_T2',
    'SINLH01-DBAM010:EOM1_T1-VALID',
    'SINLH01-DBAM010:EOM1_T2-VALID',
    'SINLH01-DBAM010:EOM2_RESOLUTION1',
    'SINLH01-DBAM010:EOM2_RESOLUTION2',

    "S10BC01-DBAM070:ADC0-DATA",
    "S10BC01-DBAM070:ADC1-DATA",
    "S10BC01-DBAM070:BAM_CH1_NORM",
    "S10BC01-DBAM070:BAM_CH2_NORM",
    'S10BC01-DBAM070:EOM1_RESOLUTION1',
    'S10BC01-DBAM070:EOM1_RESOLUTION2',
    'S10BC01-DBAM070:EOM1_T1',
    'S10BC01-DBAM070:EOM1_T2',
    'S10BC01-DBAM070:EOM1_T1-VALID',
    'S10BC01-DBAM070:EOM1_T2-VALID',
    'S10BC01-DBAM070:EOM2_RESOLUTION1',
    'S10BC01-DBAM070:EOM2_RESOLUTION2',

    "SARCL01-DBAM110:ADC0-DATA",
    "SARCL01-DBAM110:ADC1-DATA",
    "SARCL01-DBAM110:BAM_CH1_NORM",
    "SARCL01-DBAM110:BAM_CH2_NORM",
    'SARCL01-DBAM110:EOM1_RESOLUTION1',
    'SARCL01-DBAM110:EOM1_RESOLUTION2',
    'SARCL01-DBAM110:EOM1_T1',
    'SARCL01-DBAM110:EOM1_T2',
    'SARCL01-DBAM110:EOM1_T1-VALID',
    'SARCL01-DBAM110:EOM1_T2-VALID',
    'SARCL01-DBAM110:EOM2_RESOLUTION1',
    'SARCL01-DBAM110:EOM2_RESOLUTION2',

    "SARUN20-DBAM020:ADC0-DATA",
    "SARUN20-DBAM020:ADC1-DATA",
    "SARUN20-DBAM020:BAM_CH1_NORM",
    "SARUN20-DBAM020:BAM_CH2_NORM",
    'SARUN20-DBAM020:EOM1_RESOLUTION1',
    'SARUN20-DBAM020:EOM1_RESOLUTION2',
    'SARUN20-DBAM020:EOM1_T1',
    'SARUN20-DBAM020:EOM1_T2',
    'SARUN20-DBAM020:EOM1_T1-VALID',
    'SARUN20-DBAM020:EOM1_T2-VALID',
    'SARUN20-DBAM020:EOM2_RESOLUTION1',
    'SARUN20-DBAM020:EOM2_RESOLUTION2',
]



PMOS_channels = [
#    "SATOP31-PMOS132-2D:SPECTRUM_CENTER",
#    "SATOP31-PMOS132-2D:SPECTRUM_FWHM",
#    "SATOP31-PMOS132-2D:SPECTRUM_X",
#    "SATOP31-PMOS132-2D:SPECTRUM_Y",
#    "SATOP31-PMOS132-2D:processing_parameters",
#    "SATMA02-RLLE-DSP:PHASE-VS",
#    "SATMA02-RLLE-DSP:AMPLT-VS",
    "SATOP21-PMOS127-2D:SPECTRUM_X",
    "SATOP21-PMOS127-2D:SPECTRUM_Y",
    "SATSY02-DBPM020:X2",
    "SATSY02-DBPM210:X2",
    "SATSY03-DBPM030:X2",
    "SATSY03-DBPM060:X2",
    "SATSY03-DBPM090:X2",
    "SATSY03-DBPM120:X2",
    "SATCL01-DBPM140:X2",
    "SATDI01-DBPM210:X2",
    "SATDI01-DBPM240:X2",
    "SATDI01-DBPM270:X2",
    "SATDI01-DBPM310:X2",

    "SATSY02-DBPM020:Y2",
    "SATSY02-DBPM210:Y2",
    "SATSY03-DBPM030:Y2",
    "SATSY03-DBPM060:Y2",
    "SATSY03-DBPM090:Y2",
    "SATSY03-DBPM120:Y2",
    "SATCL01-DBPM140:Y2",
    "SATDI01-DBPM210:Y2",
    "SATDI01-DBPM240:Y2",
    "SATDI01-DBPM270:Y2",
    "SATDI01-DBPM310:Y2",

    "SATBD02-DBPM010:Q2",
    "SATBD02-DBPM010:Q2-VALID",
    "SATBD02-DBPM010:X2",
    "SATBD02-DBPM010:Y2",
    "SATMA02-RLLE-DSP:PHASE-VS",
    "SATMA02-RLLE-DSP:AMPLT-VS",
    "SATFE10-PEPG046:FCUP-INTENSITY-CAL"
]



SASE_SPEC_CHANNELS = [
    "SATOP31-PMOS132-2D:SPECTRUM_X",
    "SATOP31-PMOS132-2D:SPECTRUM_Y",
    "SATOP11-PSAS079:SPECTRUM_X",
    "SATOP11-PSAS079:SPECTRUM_Y", 
    "SATOP11-PSAS079:SPECTRUM_Y_SUM",
    "SATOP11-PSAS079:FPICTURE"]

for n in names_cam_pco:
    for s in suffices_proc:
        c = f"{n}.{s}"
        channels_cam_pco.append(c)



# combine all channels:
channels = channels_nbs + channels_inten + channels_cam_gige + channels_ioxos + channels_events + channels_ks + channels_cam_pco + SASE_SPEC_CHANNELS
#channels = channels_ocean_optics + channels_ks
#channels = channels_events + channels_ks + channels_inten + channels_cam_pco + channels_ocean_optics
#channels = channels_events + channels_ks


pvs = [
    'SATBD01-MBND200:P-READ',
    'SATCB01:ENE-FILT-OP',
    "SATES20-MANIP2:MOTOR_1.VAL", 
    "SATES20-MANIP2:MOTOR_2.VAL", 
    "SATES20-MANIP2:MOTOR_3.VAL", 
    "SATES20-MANIP2:MOTOR_1.RBV", 
    "SATES20-MANIP2:MOTOR_2.RBV", 
    "SATES20-MANIP2:MOTOR_3.RBV", 
    "SATES21-VM-VT2020:PRESSURE.VAL",
    "SATES21-VM-VT2010:PRESSURE.VAL",
    "SATES21-VM-VT2030:PRESSURE.VAL",
    "SATES21-VM-VT3010:PRESSURE.VAL",
    "SATES21-VM-VT3020:PRESSURE.VAL",
    "SATES21-VM-VT3040:PRESSURE.VAL",
    "SATES21-VM-VT1010:PRESSURE.VAL",
    "SATES21-VM-VT1020:PRESSURE.VAL",
    "SATES21-VM-VT1030:PRESSURE.VAL",
    "SATES21-XSHV166:V-0-S-CH9", 
    "SATES21-XSHV166:V-0-S-CH10", 
    "SATES21-XSHV166:V-1-S-CH9", 
    "SATES21-XSHV166:V-1-S-CH10", 
    "SATES21-XSMA166:MOT1:MOTRBV", 
    "SATES21-XSMA166:MOT2:MOTRBV", 
    "SATES21-XSMA166:MOT3:MOTRBV", 
    "SATES22-XSMA168:MOT10:MOTRBV", 
    "SATES22-XSMA168:MOT11:MOTRBV", 
    "SATES22-XSMA168:MOT12:MOTRBV", 
    "SATFE10-OATT064:MOT2TRANS.VALD", 
    "SATFE10-OATT065:MOT2TRANS.VALD", 
    "SATUN14-MBND100:I-READ", 
    "SF-CPCL-TIM:TIME", 
    "SLAAT01-LTIM-PDLY:DELAY", 
    "SLAAT21-LMOT-M701:MOT", 
    "SLAAT21-LMOT-M702:MOT", 
    "SLAAT21-LMOT-M703:MOT", 
    "SLAAT21-LMOT-M704:MOT", 
    "SLAAT21-LMOT-M705:MOT", 
    "SLAAT21-LMOT-M706:MOT", 
    "SLAAT21-LMOT-M708:MOT",
    "SLAAT21-LMOT-M714:MOT",
    "SLAAT21-LMOT-M712:MOT",
    "SWISSFEL-STATUS:Bunch-2-Appl-Freq-RB", 
    "SLAAT01-LCAM-C601:FIT-XPOS", 
    "SLAAT01-LCAM-C601:FIT-YPOS", 
    "SLAAT01-LCAM-C601:INTEGRAL_AVE", 
    "SLAAT21-LCAM-C701:FIT-XPOS", 
    "SLAAT21-LCAM-C701:FIT-YPOS", 
    "SLAAT21-LCAM-C701:INTEGRAL_AVE", 
    "SLAAT21-LCAM-C703:FIT-XPOS", 
    "SLAAT21-LCAM-C703:FIT-YPOS", 
    "SLAAT21-LCAM-C703:INTEGRAL_AVE", 
    "SATES20-CVME-EVR0:Pul14-Delay-SP",
    "SLAAT21-LENG-LAKE1:GET_TEMP",
    "SATFE10-VMFR054-A050:PRESSURE",
    "SATOP11-OSGM087:photonenergy",
    "SATOP11-OSGM087:bandwidth",
    "SATUN:FELPHOTENE",
    "SATFE10-OGAT053:transmission",
    "SATES20-CWAG-GEP01:TEMP09",
    "SATES20-CWAG-GEP01:TEMP10",
    "SATES20-CWAG-GEP01:TEMP11",
    "SLAAT01-LTIM-PDLY:DELAY_Z_OFFS",
    "SATES20-CVME-EVR0:Pul12_NEW_DELAY",
    "SATES20-CVME-EVR0:Pul11-Delay-SP"
]


pvs += [
    f"SATES20-CVME-EVR0:DUMMY_PV{i+1}_NBS.INP" for i in range(10)
]

pvs += [
    f"SATUN{i:02}-UIND030:FELPHOTENE" for i in range(6, 22+1) if i != 14
]

pvs += [
    f"SATUN{i:02}-UIND030:POL-SET" for i in range(6, 22+1) if i != 14
]

# add scope channels here:
pvs += [
    "DPO:FrameNumber", 'DPO:Repetitions', 'VXGC:Freq', 'VXGC:Phase', 'VXGC:Power', 'VXGC:Outstate', 'VXGC:LockStatus'
]


for n in ("TEMP", "HUMIREL", "PRES"):
    for i in range(5):
        pvs.append(f"SLAAT01-LI2C01_CH{i+1}:{n}")
    for i in range(2):
        pvs.append(f"SLAAT21-LI2C01_CH{i+1}:{n}")
    for i in range(4):
        pvs.append(f"SLAAT21-LI2C02_CH{i+1}:{n}")



